import 'dart:io';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import '../vApi.dart';
import '../vFirebase.dart';
import '../vImage.dart';
import '../vSystem.dart';
import '../vTimer.dart';
import '_Send_File.dart';
import '_Send_Message.dart';
import '_Send_Photo.dart';
import '_Send_query.dart';


class $$eChat_View extends StatefulWidget {
   var url;
   var onMessage;
   Map<String,String> post;
   Color Self_bgcolor;
   Color Other_bgcolor;
   Color self_fontcolor;
   Color other_fontcolor;

   String Send_message_url;
   int last_id = 0;
   int refresh_time = 0;

   $$eChat_View({this.url,this.post,this.Self_bgcolor,this.Other_bgcolor,this.self_fontcolor,this.other_fontcolor,this.Send_message_url,
     this.onMessage,
     this.refresh_time = 0,Key key}): super(key: key);


   @override
   $$eeChat_ViewtState createState() => $$eeChat_ViewtState();
}

class $$eeChat_ViewtState extends State<$$eChat_View> implements FireBase_CallBack {

  vApi api = vApi();
  Send_Query send_query;
  var loaded = false;
  var error = false;
  vTimer timer;
  List data;

  ScrollController _controller;

  void initState() {
    _controller = ScrollController();
    _controller.addListener(_scrollListener);
    send_query = Send_Query(chat_view: widget);
    timer = vTimer();
    vFirebase.initState_CallBack(this);
  }

  _scrollListener() {
    if (_controller.offset >= _controller.position.maxScrollExtent &&
        !_controller.position.outOfRange) {
    }
    if (_controller.offset <= _controller.position.minScrollExtent &&
        !_controller.position.outOfRange) {
    }
  }

  @override
  void dispose() {
    api.$Stop();
    send_query.dispose();
    timer.stop();
    vFirebase.dispose(this);
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    //print("Chat view build $error" );
    if(error)
      {  return _Error_Reload(context); }


    if(!loaded) {
      //print("chat view post : " + widget.post.toString());

      Map<String,String> post = widget.post;
      post["last_id"] = "0";

      api.$post(widget.url,postValue:post,
          onData: (json) {
            widget.last_id = int.parse(json["sdata"]["last_id"]);
            setState(() {
              data = json["data"];
              loaded = true;
              error = false;
            });
          },
          onError: () {
            print("On Connect Error");
            setState(() {
              error = true;
              loaded = false;
            });
          },
      );

      return Center(
          child: SizedBox(
              child:
              new CircularProgressIndicator(
                  valueColor: new AlwaysStoppedAnimation(Colors.blue),
                  strokeWidth: 5.0),
              height: 40.0,
              width: 40.0));
    }
   else
    {
       if(widget.refresh_time>0)
         {  timer.start(widget.refresh_time,widget.refresh_time, onfinish: time_refresh); }
       return _listview();


    }
  }

  void time_refresh()
  {  //print("Chat Refresh:");
     _Load_Message();
  }


  Widget _Error_Reload(BuildContext context)
  {  return Center(child: Column(
    mainAxisAlignment: MainAxisAlignment.center,
    children: <Widget>[
      Icon(Icons.error_outline,color: Colors.amber,size: 110),
      RaisedButton(child: Icon(Icons.refresh,size: 25,),onPressed: (){
        setState(() {
          error = false;
          loaded = false;
        });
      },)
    ],),);
  }


  Widget _listview()
  { return GestureDetector(
      child: ListView.builder(itemCount: data.length,
        padding: EdgeInsets.all(10.0),
        controller: _controller,
        reverse: true,
        itemBuilder: (context, index) {
        return Container(width: double.infinity,
            alignment: (data[index]["type"] == "1") ? Alignment.topRight : Alignment.topLeft,
            child: message_item(data[index])
        );
     }),
     onTap: (){ print("Tap "); FocusScope.of(context).requestFocus(FocusNode());

     _Load_Message();
    },
    onTapDown: (TapDownDetails details)  { print("Tap Down"); FocusScope.of(context).requestFocus(FocusNode());},
   );
  }

  Widget message_item(sdata)
  {   if(sdata["type"] == "1" || sdata["member_icon"]=="")
        return message_item_body(sdata);
      else
        return Row(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: <Widget>[
           Padding(
             padding: const EdgeInsets.only(top:5.0),
             child: vImage(image: sdata["member_icon"]).circle(30)
            ),
            message_item_body(sdata)
        ],);


  }

  Widget message_item_body(sdata) {

    Color fontcolor = (sdata["type"] == "1") ? widget.self_fontcolor : widget.other_fontcolor;
    Color bg_color = (sdata["type"] == "1") ? widget.Self_bgcolor : widget.Other_bgcolor;

    if (sdata["send_out"] == "1" ) {
       return sdata["widget"];
    }

    switch(sdata["message_type"])
    {  case "0" : // Message
         return Card(
           child: ClipRRect(
            borderRadius: BorderRadius.circular(5.0),
            child: Stack(
              children: <Widget>[
                Container(
                  padding: EdgeInsets.symmetric(horizontal: 10,vertical: 5),
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: <Widget>[

                      (sdata["type"]) == "0" && sdata["member_name"]!="" ? Text(
                          sdata["member_name"],
                          style: TextStyle(color: Color(
                              int.parse(sdata["member_color"], radix: 16)))): Container(width:0),

                      Text(sdata["message"].toString(),
                        style: TextStyle(color: fontcolor),),


                      SizedBox(height: 13,),
                    ],
                  ),
                  color: bg_color,
                  constraints: BoxConstraints(
                    maxWidth: 300,
                    minWidth: 100,
                  ),
                ),

                Positioned(
                  right: 5,
                  bottom: 3,
                  child: Text(sdata["time"], style: TextStyle(fontSize: 10,
                      color: fontcolor.withOpacity(0.7)),
                    textAlign: TextAlign.right,),
                ),
              ],
            )),
      );
     break;

     case "1" : // Image
      return Card(
        child: ClipRRect(
            borderRadius: BorderRadius.circular(5.0),
            child: Container(
              padding: EdgeInsets.all(4.0),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  (sdata["type"]) == "0" && sdata["member_name"]!="" ? Text(
                      sdata["member_name"],
                      style: TextStyle(color: Color(
                          int.parse(sdata["member_color"], radix: 16)))): Container(width:0),

                  Stack(children: <Widget>[
                  vImage(image:sdata["file"]).r(5).size(200).zoom(),
                  Positioned(right:5,bottom:0, child:
                  Padding(
                      padding: const EdgeInsets.all(5.0),
                      child: Text(sdata["time"],
                          style: TextStyle(fontSize: 10, color: Colors.white)),
                    ),)
                  ],),
                ],
              ),
              color: sdata["type"] == "1" ? widget.Self_bgcolor : widget.Other_bgcolor,
            )),
      ); break;


     case "2":
      return GestureDetector(
        onTap: (){ vSystem.$open_URL(sdata["file"]); },
        child: Stack(
          children: <Widget>[
            Card(
              child: ClipRRect(
                  borderRadius: BorderRadius.circular(5.0),
                  child: Container(
                      color: bg_color,
                      constraints: BoxConstraints(
                        maxWidth: 220,
                        minWidth: 100,),

                      padding: EdgeInsets.all(6.0),
                      child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: <Widget>[
                        (sdata["type"]) == "0" && sdata["member_name"]!="" ? Text(
                            sdata["member_name"],
                            style: TextStyle(color: Color(
                                int.parse(sdata["member_color"], radix: 16)))): Container(width:0),

                        SizedBox(height: 2,),
                        Row(children: <Widget>[
                          ClipRRect(borderRadius: BorderRadius.circular(15.0),
                              child: Container(width: 30, height: 30,
                                color: Colors.blue,
                                child: Center(child: Icon(
                                    Icons.insert_drive_file, size: 20,
                                    color: Colors.white)),)
                          ),

                          SizedBox(width: 8,),
                          Expanded(
                            child: Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: <Widget>[
                              Text(sdata["filename"].toString(), overflow: TextOverflow.ellipsis,
                                style: TextStyle(color: fontcolor),),
                              Text(sdata["filesize"], style: TextStyle(fontSize: 10,
                                  color: fontcolor.withOpacity(0.7)),),
                            ],),
                          ),
                        ],),
                      ],))),
            ),
            Positioned(
              right: 15,
              bottom: 8,
              child: Text(sdata["time"], style: TextStyle(fontSize: 10,
                  color: fontcolor.withOpacity(0.7)),
                textAlign: TextAlign.right,),
            ),
           ],
          ),
         ); break;

        default:
          if(widget.onMessage!=null)
             {  return widget.onMessage(sdata); }
      }
  }


  void Send_Message(String message)
  {   if(message.replaceAll(" ","") == "" )
         { return; }
      Map<String,dynamic> sdata = Map();
      sdata["message"] = message;
      sdata["type"] = "1";
      sdata["send_out"] = "1";
      sdata["message_type"] = "0";
      sdata["time"] = DateTime.now().toString().substring(11,16);
      sdata["widget"] =  $$Chat_Send_Message(key:GlobalKey(),url: widget.Send_message_url,
      fontcolor: widget.self_fontcolor,
      bgcolor: widget.Self_bgcolor,
      post: widget.post,
      sdata: sdata,
      send_query: send_query,
      onSuccess: Send_Out_Received);

      setState(() {
        data.insert(0,sdata);
      });

  }

  void Send_Photo(File file)
  {    Map<String,dynamic> sdata = Map();
       sdata["message"] = "";
       sdata["type"] = "1";
       sdata["send_out"] = "1";
       sdata["photo"] = file;
       sdata["message_type"] = "1";
       sdata["time"] = DateTime.now().toString().substring(11,16);

       sdata["widget"] =  $$Chat_Send_Photo(key:GlobalKey(),url: widget.Send_message_url,
        fontcolor: widget.self_fontcolor,
        bgcolor: widget.Self_bgcolor,
        post: widget.post,
        sdata: sdata,
        send_query: send_query,
        onSuccess: Send_Out_Received);

     setState(() {
        data.insert(0,sdata);
     });

  }

  void Send_File(File file)
  {    Map<String,dynamic> sdata = Map();
       sdata["message"] = "";
       sdata["type"] = "1";
       sdata["send_out"] = "1";
       sdata["file"] = file;
       sdata["message_type"] = "1";
       sdata["time"] = DateTime.now().toString().substring(11,16);

      sdata["widget"] =  $$Chat_Send_File(key:GlobalKey(),url: widget.Send_message_url,
      fontcolor: widget.self_fontcolor,
      bgcolor: widget.Self_bgcolor,
      post: widget.post,
      sdata: sdata,
      send_query: send_query,
      onSuccess: Send_Out_Received);

  setState(() {
    data.insert(0,sdata);
  });


  }

  void Send_Out_Received(js)
   { print("received " + js.toString()) ;
     var id = int.parse(js["sdata"]["last_id"]);
     if(id>widget.last_id)
         { widget.last_id = id; }

     setState(() {
       js["data"].forEach((dynamic value) {
         data.insert(0,value);
       }); });
   }

  void _Load_Message()
  { if(send_query.action == true)
       { return; }

    var post = widget.post;
         post["last_id"] = widget.last_id.toString();

     api.$post(widget.url, postValue: post,
      onData: (js) {
       widget.last_id =  int.parse(js["sdata"]["last_id"]);
       setState(() {
          js["data"].forEach((dynamic value) {
            data.insert(0,value);
          });

        if(js["data"].length >0)
           { SystemSound.play(SystemSoundType.click); }
        });
      });
   }

  @override
  FireBase_OnMessage(message) {
    _Load_Message();
  }




}


