import 'package:flutter/material.dart';
import '../vSpace.dart';
import '../vText.dart';
import '_Send_query.dart';


class $$Chat_Send_File extends StatefulWidget {
  var url;
  var sdata;
  var post;
  var onSuccess;
  var fontcolor;
  String  error_message;

  Color bgcolor;

  var error = false;
  var success = false;
  var visible = 0.5;
  var api_loaded = false;

  Send_Query send_query;

  $$Chat_Send_File({this.fontcolor,this.bgcolor,this.url,this.post,this.sdata,this.onSuccess,this.send_query,Key key}):super(key:key);

  @override
  _$$Chat_Send_FileState createState() => _$$Chat_Send_FileState();
}

class _$$Chat_Send_FileState extends State<$$Chat_Send_File> implements Send_Return {

  var percent = "0%";

  @override
  Widget build(BuildContext context) {
    if(!widget.api_loaded)
     {  widget.api_loaded = true;
         widget.send_query.add(widget.url, widget.post, {"photo":widget.sdata["file"]}, this);
     }

    if(widget.error)
    {  return Container(
        padding: EdgeInsets.all(5),
        //width: 120,
        child: Row(children: <Widget>[
        vSp(0).expend(),
         Icon(Icons.error,color: Colors.amber,size: 25,),
         SizedBox(width: 5,),
         vText(widget.error_message).s1(),
      ],),
    );
    }
    else
    {  return body(context); }
  }

  Widget body(context){
    double w = MediaQuery.of(context).size.width > 400 ? 300 : 200;

    return ClipRRect(
        borderRadius: BorderRadius.circular(5.0),
        child: Stack(
          children: <Widget>[
            Container(
                color: widget.bgcolor.withOpacity(widget.visible),
                constraints: BoxConstraints(
                  maxWidth: w,
                  minWidth: 100,),

                padding: EdgeInsets.all(8.0),
                child: Column(children: <Widget>[
                  SizedBox(height: 2,),
                  Row(children: <Widget>[
                    Opacity(
                      opacity: widget.visible,
                      child: ClipRRect(borderRadius: BorderRadius.circular(15.0),
                          child: Container(width: 30, height: 30,
                            color: Colors.blue,
                            child: Center(child: Icon(
                                Icons.insert_drive_file, size: 20,
                                color: Colors.white)),)
                      ),
                    ),
                    SizedBox(width: 8,),
                    Expanded(
                      child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: <Widget>[
                        Text(widget.sdata["file"].path.split("/").last,
                          style: TextStyle(color: widget.fontcolor.withOpacity(widget.visible)),overflow: TextOverflow.ellipsis,),
                          vText(percent,sKey:"percent").c(Colors.black).s2(),
                      ],),
                    )
                  ],),
                ],)),
            Positioned(right:10, bottom:5,
                child: Text(widget.sdata["time"], style: TextStyle(fontSize: 10, color: widget.fontcolor.withOpacity(0.7)),)),

          ],
        ));
     }


  @override
  void error_return(String err_message) {
    setState(() {
      widget.error = true;
      widget.error_message = err_message;
    });
  }

  @override
  void process_return(send, total) {
    //print("Proccess $send, $total");
    percent = (send/total * 99).round().toString() + "%";
    vText.$skey("percent").$Text(percent);
  }

  @override
  void success_return(data) {
    setState(() {
      percent = "100%";
      widget.visible = 1;
      widget.onSuccess(data);
    });
  }

}
