import 'package:flutter/material.dart';
import 'package:flutter_slidable/flutter_slidable.dart';
import '../vApi.dart';
import '../vSystem.dart';


class $$Api_ListView extends StatefulWidget {
  static const delete = {"1":"Delete","2":"刪除"};

  var url;
  var post;
  var table_item;
  var pagesize;
  String nodata_text;

  var ondelete;

  _$$Api_ListViewState _stateitem;

  int column;
  double gridRatio;

  $$Api_ListView({this.url,this.post,this.table_item,this.pagesize = 20,this.ondelete,this.nodata_text="no data",this.column = 0,this.gridRatio = 1,Key key}): super(key: key){}

  @override
  _$$Api_ListViewState createState() {
    _stateitem = _$$Api_ListViewState();
    return _stateitem;
  }

  reload({String url,post}) {
    this.url = url ?? this.url;
    this.post = post ?? this.post;
    _stateitem.reload();
  }
}

class _$$Api_ListViewState extends State<$$Api_ListView> {

  var api = vApi();
  var loaded = false;
  var error = false;
  var page = 1;
  var all_loaded = false;
  List<int> remove_index = [];

  List data;
  Map<int,Widget> item = Map();

  ScrollController _controller;

  void initState() {
    _controller = ScrollController();
    _controller.addListener(_scrollListener);
  }

  _scrollListener() {
    if (_controller.offset >= _controller.position.maxScrollExtent &&
        !_controller.position.outOfRange) {
      _PageLoad();
    }
    if (_controller.offset <= _controller.position.minScrollExtent &&
        !_controller.position.outOfRange) {
    }
  }

  @override
  void dispose() {
    // TODO: implement dispose
    api.$Stop();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if(error)
    {  return _Error_Reload(context); }

    if(!loaded) {
      page = 1;
      var post = widget.post ?? Map<String,String>();
      post["pageno"] =  page.toString();
      post["pagesize"] = widget.pagesize.toString();

      api.$post(widget.url, postValue: post,
          onData: (result) {
            setState(() {
              data = result["data"];
              loaded = true;
              error = false;
            });
          },
          onError: () {
            setState(() {
              error = true;
              loaded = false;
            });
          });

      return AspectRatio(aspectRatio: 1.5,
        child: Center(
            child: SizedBox(
                child:
                new CircularProgressIndicator(
                    valueColor: new AlwaysStoppedAnimation(Colors.blue),
                    strokeWidth: 5.0),
                height: 40.0,
                width: 40.0)),
      );
    }
    else
    {
      if(widget.column >1)
      {  return _gridview(); }
      else
      { return _listview(); }
    }
  }

  Widget _gridview()
  {  if(data.length == 0)
  {  return _no_data(); }
  else
  { if(data.length < widget.pagesize)
  { all_loaded = true; }

  return  RefreshIndicator(
      onRefresh: () {
        reload();
      },
      child: GridView.builder(itemCount: data.length,
        controller: _controller,
        gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
            crossAxisCount: widget.column,
            childAspectRatio: widget.gridRatio
        ),

        padding: EdgeInsets.all(0),
        physics: const AlwaysScrollableScrollPhysics(),
        itemBuilder: (context, index) {

          if(item[index]==null)
          { item[index] = widget.table_item(data[index]);}
          if (index == data.length - 1 && !all_loaded) {
            return Column(crossAxisAlignment: CrossAxisAlignment.start,
              children: <Widget>[
                item[index],
                Container(
                  //color: Colors.grey.withOpacity(0.1),
                  padding: EdgeInsets.all(50),
                  child: SizedBox(
                      child:
                      new CircularProgressIndicator(
                          valueColor: new AlwaysStoppedAnimation(
                              Colors.black),
                          strokeWidth: 2.0),
                      height: 15.0,
                      width: 15.0),
                )
              ],
            );
          }
          else
            return item[index];
        },
      ));
  }
  }


  Widget _listview()
  {  if(data.length == 0)
  {  return _no_data(); }
  else
  { if(data.length < widget.pagesize)
  { all_loaded = true; }

  return  RefreshIndicator(
      onRefresh: () {
        reload();
      },
      child: ListView.builder
        (itemCount: data.length,
        controller: _controller,
        padding: EdgeInsets.all(0),
        physics: const AlwaysScrollableScrollPhysics(),
        itemBuilder: (context, index) {
          if(remove_index.indexOf(index)>=0)
          {  return Container(); }

          if(item[index] == null)
          {  if(widget.ondelete==null)
          { item[index] = widget.table_item(data[index]); }
          else
          { item[index] = Slidable(actionPane: SlidableDrawerActionPane(),
            actionExtentRatio: 0.2,
            child: widget.table_item(data[index]),
            secondaryActions: <Widget>[
              IconSlideAction(
                caption: $$Api_ListView.delete[vSystem.Lang_id],
                color: Colors.red,
                icon: Icons.delete,
                onTap: (){ widget.ondelete(data[index],(){
                  setState(() {
                    remove_index.add(index);
                  });
                }); },
              ),
            ],

          );
            /*
                      Dismissible(key:GlobalKey(),child: widget.table_item(data[index]),

                       direction : DismissDirection.endToStart,
                       background: Container(),
                       secondaryBackground: Container(
                          padding: EdgeInsets.symmetric(horizontal: 20),
                          alignment: Alignment.centerRight,
                          color: Colors.red,
                          child:Icon(Icons.delete,color: Colors.white,size: 35,)
                       ),
                      onDismissed: (direction){
                         widget.ondelete(data[index]);
                      },
                     );

                       */

          }
          }



          if (index == data.length - 1 && !all_loaded) {
            return Column(
              children: <Widget>[
                item[index],
                Container(
                  color: Colors.grey.withOpacity(0.2),
                  padding: EdgeInsets.all(10),
                  child: Center(
                      child: SizedBox(
                          child:
                          new CircularProgressIndicator(
                              valueColor: new AlwaysStoppedAnimation(
                                  Colors.black),
                              strokeWidth: 2.0),
                          height: 15.0,
                          width: 15.0)),
                )
              ],
            );
          }
          else
            return item[index];
        },
      ));

  }

  }

  Widget _no_data() {
    return Center(child: Text(vSystem.lang_text(widget.nodata_text),textAlign: TextAlign.center,),);
  }

  Widget _Error_Reload(BuildContext context)
  {  return Center(child: Column(
    mainAxisAlignment: MainAxisAlignment.center,
    children: <Widget>[
      Icon(Icons.error_outline,color: Colors.amber,size: 110),
      RaisedButton(child: Icon(Icons.refresh,size: 25,),onPressed: (){
        setState(() {
          error = false;
          loaded = false;
        });
      },)
    ],),);
  }

  void _PageLoad()
  { if(all_loaded) return;

  page = page  + 1;
  var post = widget.post ?? Map<String,String>();
  post["pageno"] = "$page";
  post["pagesize"] = widget.pagesize.toString();

  api.$post(widget.url, postValue: post,
      onData: (result) {
        setState(() {
          if(result["data"].length < widget.pagesize)
          { all_loaded = true; }

          result["data"].forEach((dynamic value) {
            data.add(value);
          });
        });
      });
  }

  void reload()
  {  api.$Stop();
  setState(() {
    data.clear();
    page = 1;
    loaded = false;
    error = false;
    all_loaded = false;
    item.clear();
  });
  }
}


