import 'dart:convert';
import 'package:flutter/material.dart';
import '../vButton.dart';
import '../vText.dart';
import '../vSystem.dart';
import 'package:http/http.dart' as http;

class $$Api_WebListView extends StatefulWidget {
  String url;
  var post;
  var onData;
  int page_xalign;
  int page_yalign;
  var item_align;


  int page = 1;
  int pagesize;

  String nodata_text;
  double ratio;
  var snapdata;

  int mobile_col;
  int tablet_col;
  int destop_col;
  int large_destop_col;

  Color pagvButton_focus_color;
  Color pagvButton_fontcolor;
  Color pagvButton_bgcolor;

  $$Api_WebListView({Key key,this.url,this.post,this.onData,
  this.pagesize=50,
  this.nodata_text = "No Data",
  this.mobile_col = 2,
  this.tablet_col = 4,
  this.destop_col = 6,
  this.large_destop_col = 8,
  this.pagvButton_focus_color = Colors.red,
  this.pagvButton_fontcolor = Colors.black,
  this.pagvButton_bgcolor = Colors.white,
  this.page_xalign,
  this.page_yalign,
  this.item_align = CrossAxisAlignment.start,
  }):super(key:key);

  @override
  _$$Api_WebListViewtate createState() => _$$Api_WebListViewtate();
}

class _$$Api_WebListViewtate extends State<$$Api_WebListView> {
  var device_col;
  var post;

  @override
  void initState() {
    super.initState();
    post = widget.post;
    device_col = [
      widget.mobile_col,
      widget.tablet_col,
      widget.destop_col,
      widget.large_destop_col
    ];
    post["pageno"] = widget.page.toString();
    post["pagesize"] = widget.pagesize.toString();
  }

  @override
  Widget build(BuildContext context) {
    post = widget.post;
    post["pageno"] = widget.page.toString();
    post["pagesize"] = widget.pagesize.toString();


    if (widget.snapdata == null)
      return FutureBuilder(
          future: future_api(),
          builder: (context, Snap) {
            //print("Connection:" + Snap.connectionState.toString());

            if (Snap.connectionState == ConnectionState.done) {
              if (Snap.hasError) {
                return Column(children: [
                  Center(
                    child: Icon(
                        Icons.error_outline, color: Colors.grey, size: 100),
                  ),
                ],);
              }
              else {
                return showwidget();
              }
            }
            else {
              return Column(children: [
                AspectRatio(aspectRatio: 1.5,
                  child: Center(
                    child: Padding(
                      padding: const EdgeInsets.all(40.0),
                      child: CircularProgressIndicator(),
                    ),
                  ),
                ),
              ],);
            }

            return Container();
          });
    else {
      return showwidget();
    }
  }

  Future future_api() async {
    //print("Url " + widget.url + ":" + post.toString());
    var response = await http.post(Uri.parse(widget.url), body: post);
    if (response.statusCode == 200) {
      //print("Web Page API return :" + response.body.toString());
      widget.snapdata = jsonDecode(response.body);
      return widget.snapdata;
    } else {
      throw Exception('Failed to load album');
    }
  }

  Widget showwidget() {
    List<Widget> item = [];
    var data = widget.snapdata["data"];
    //print("data：" + data.toString());

    for (var n = 0; n < data.length; n++) {
      //print("show:" + data[n].toString());
      item.add(widget.onData(data[n]));
    }

    return LayoutBuilder(
        builder: (context, constraints) {
          var sid = vSystem.screensize_ID(context);
          int col = device_col[sid];
          if (col == 0) {
            return Container();
          }

          if (item.length == 0) {
            return Center(child: vText(widget.nodata_text));
          }


          var v = 100 / (col * 100);
          List<Widget> citems = [];
          for (var n = 0; n < item.length; n++) {
            citems.add(
                FractionallySizedBox(
                    widthFactor: v,
                    child: item[n]
                )
            );
          }
          return Column(
            crossAxisAlignment: widget.item_align,
            children:
            [ widget.page_yalign == 0 ? page_button() : Container(),
              Wrap(children: citems),
              widget.page_yalign == 1 ? page_button() : Container(),
            ],);
        });
  }


  Widget page_button() {
    List<Widget> pagelist = [];
    var totalpage = widget.snapdata["sdata"]["totalpage"].toInt();
    if (totalpage <= 1) {
      return Container();
    }

    var postpage = widget.page;

    //print("post page $postpage");
    for (var v = 1; v <= totalpage; v++) {
      var color = (v == postpage) ? widget.pagvButton_focus_color : widget
          .pagvButton_fontcolor;

      vButton b = vButton("$v").c(Colors.grey.withOpacity(0.1)).tc(color).m(1).px(0).fontsize(13).onOver_c(Colors.white).onPress((){
          setState(() {
             widget.page = v;
             post["pageno"] = v.toString();
             widget.snapdata = null;
           });
      });

      if(v == postpage)
         {  b = vButton("$v").c(color).m(1).p(0).fontsize(13).outline(); }

      pagelist.add(b);

    }

      var child =  Padding(
        padding: const EdgeInsets.all(8.0),
        child: Wrap(children: pagelist),
      );

      switch(widget.page_xalign) {
        case 0:
          return Row(children: [
            child,
            Expanded(child: SizedBox(height: 1,)),
          ],);

        case 1:
          return Row(children: [
            Expanded(child: SizedBox(height: 1,)),
            child,
            Expanded(child: SizedBox(height: 1,)),
          ],);

        case 2:
          return Row(children: [
            Expanded(child: SizedBox(height: 1,)),
            child,
          ],);
      }

    }



}
