import 'dart:io';
import 'package:flutter/material.dart';
import 'package:image_crop/image_crop.dart';

class $$ImageCrop_Page extends StatelessWidget {
  File imagefile;
  final cropKey = GlobalKey<CropState>();
  var cropradio = 1.0;

  $$ImageCrop_Page({Key key, this.imagefile,this.cropradio}): super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
        ),
        body: Container(
            color: Colors.black,
            padding: const EdgeInsets.all(10.0),
            child:
            Column(
              children: <Widget>[
                Expanded(
                  child: Crop(
                    key: cropKey,
                    image: FileImage(imagefile),
                    maximumScale: 1,
                    alwaysShowGrid: true,
                    aspectRatio: cropradio,

                  ),
                ),
                Row(
                  mainAxisAlignment: MainAxisAlignment.spaceAround,
                  children: <Widget>[
                    RaisedButton(
                      color: Colors.blueAccent,
                      child: Icon(Icons.check, size: 25, color: Colors.white,),
                      onPressed: () async {
                        final sampleFile = await ImageCrop.sampleImage(
                            file: imagefile,
                            preferredWidth: 1024,
                            preferredHeight: 1024);

                        final crop = cropKey.currentState;
                        final croppedFile = await ImageCrop.cropImage(
                          file: sampleFile,
                          area: crop.area,
                        );
                        Navigator.of(context).pop(croppedFile);
                      },
                    ),

                    RaisedButton(
                      color: Colors.red,
                      child: Icon(Icons.cancel, size: 25, color: Colors.white,),
                      onPressed: () {
                        Navigator.of(context).pop(null);
                      },
                    ),

                  ],
                )
              ],
            ))


    );
  }}