import 'package:carousel_pro/carousel_pro.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'vWeb.dart';
import '../vImage.dart';
import '_PhotoView.dart';

class $$ProductImage extends StatefulWidget {
  List Image_Paths;
  var size_radio;
  var thumb_highlight_color;
  var autoplay;

  $$ProductImage({this.Image_Paths,this.size_radio =1.5,this.thumb_highlight_color = Colors.red,this.autoplay = false});

  @override
  _$$ProductImageState createState() => _$$ProductImageState();
}

class _$$ProductImageState extends State<$$ProductImage> {

  Widget destop;
  Widget mobile;

  @override
  void initState() {
    super.initState();
    if (widget.Image_Paths.length == 1) {
      destop = vImage(image:widget.Image_Paths[0]).ratio(widget.size_radio).box_contain();
    }
    else {
      destop = desttop_image(Image_Paths: widget.Image_Paths,
          size_radio: widget.size_radio,
          highlight_color: widget.thumb_highlight_color);
    }
    mobile = Mobile();
  }

  @override
  Widget build(BuildContext context) {
    return vResponsive(
      child: destop,
      child_Mobile: mobile,
      child_Tablet: mobile,
    );
  }


  Widget Mobile() {
    if (widget.Image_Paths.length == 1) {
      return vImage(image:widget.Image_Paths[0]).ratio(widget.size_radio).box_contain();
    }

    return Padding(
      padding: const EdgeInsets.only(bottom:10),
      child: AspectRatio(
        aspectRatio: widget.size_radio,
        child: Carousel(
            images: widget.Image_Paths.map<dynamic>((e) => NetworkImage(e))
                .toList(),
            showIndicator: true,
            dotSize: 7.0,
            dotSpacing: 20.0,
            autoplay: widget.autoplay,
            //dotColor: Colors.white,
            indicatorBgPadding: 10.0,
            dotBgColor: Colors.grey.withOpacity(0),
            //borderRadius: false,
            //moveIndicatorFromBottom: 180.0,
            //noRadiusForIndicator: true,
            //overlayShadow: true,
            //overlayShadowColors: Colors.white,
            //overlayShadowSize: 1.7,
            onImageTap: (index) {
              Navigator.push(context, MaterialPageRoute(
                  builder: (context) => $$PhotoView(image: widget.Image_Paths[index])));
            }
        ),
      ),
    );
  }
}


class desttop_image extends StatefulWidget {
  List Image_Paths;
  var size_radio;
  var highlight_color;
  desttop_image({this.Image_Paths,this.size_radio,this.highlight_color});

  @override
  _detstop_imageState createState() => _detstop_imageState();
}

class _detstop_imageState extends State<desttop_image> {
  var current_image;
  var current_page = 0;
  final PageController controller = PageController(initialPage: 0);

  @override
  void initState() {
    super.initState();
    current_image = widget.Image_Paths[0];

  }

  @override
  Widget build(BuildContext context) {

    return Material(
      color: Colors.transparent,
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
        AspectRatio(
           aspectRatio: widget.size_radio,
           child: Stack(
             children: [
               PageView(
                   scrollDirection: Axis.horizontal,
                   controller:controller,
                   children: widget.Image_Paths.map<Widget>((e){
                   return Image.network(e,fit: BoxFit.fill);}
        ).toList()),
              Center(child: Row(children: [
                SizedBox(width: 10,),
                InkWell(
                  child: Container(
                    color:Colors.transparent,
                    height: double.infinity,
                    child: Icon(Icons.arrow_back_ios,size: 50,color: Colors.white.withOpacity(0.5),)
                  ),
                  onTap: (){
                    print("Cick Left " + controller.page.toString());
                    if(controller.page >0)
                    {  controller.previousPage(duration: Duration(milliseconds: 300),curve: Curves.linear );
                       setState(() {
                         current_image = widget.Image_Paths[controller.page.toInt()- 1];
                         current_page = controller.page.toInt()- 1;
                       });
                    }
                  },
                ),



               Expanded(child: SizedBox(height: 1,)),
                InkWell(
                  child: Container(
                      color:Colors.transparent,
                      height: double.infinity,
                      child: Icon(Icons.arrow_forward_ios,size: 50,color: Colors.white.withOpacity(0.5),)
                  ),
                  onTap: (){
                    print("Cick Left " + controller.page.toString());
                    if(controller.page < widget.Image_Paths.length)
                      {  controller.nextPage(duration: Duration(milliseconds: 300),curve: Curves.linear );
                        setState(() {
                          current_image = widget.Image_Paths[controller.page.toInt()+ 1];
                          current_page = controller.page.toInt() + 1;
                        });
                      }
                  },
                ),
                SizedBox(width: 10,),


              ],),)

             ],
           )),
        SizedBox(height: 5,),
        Wrap(children: widget.Image_Paths.asMap().map((i,e){
          var color =  i == current_page ? widget.highlight_color : Colors.transparent;
          return  MapEntry(i,FractionallySizedBox(
              widthFactor: 0.199,
              child: AspectRatio(
                aspectRatio: 1.5,
                child: Container(
                  padding: const EdgeInsets.all(3.0),
                  color:color,
                  child: InkWell(child:
                  Image.network(e,fit: BoxFit.fill,),
                    onTap: (){
                      setState(() {
                        controller.animateToPage(i, duration: Duration(milliseconds: 300),curve: Curves.linear );
                        current_image = e;
                        current_page = i;

                      });
                    },
                  ),

                ),
              )));

        }).values.toList()),
          SizedBox(height: 10,),
      ],),
    );
  }
}

