
import 'package:ev_framework/_FrameWork/vBox.dart';
import 'package:ev_framework/_FrameWork/vSpace.dart';
import 'package:flutter/material.dart';
import '../../Not_FrameWork/_Web_Iframe.dart';
import '../vSystem.dart';
import '../vText.dart';

class vWeb {
  static Map<String, dynamic> _Page = Map();

  static Widget $Iframe(String src, {double frameSize_Ratio = 2}) {
     print("Iframe use \$\$Web_Iframe");
    //return $$Web_Iframe(Src: src, Frame_size_ratio: frameSize_Ratio);
  }

  static $Add_LinkPage(String path, page) {
    _Page[path] = page;
  }

  static Route<dynamic> $Route(RouteSettings settings) {
    var pagename = settings.name.split("?")[0];
    if (_Page[pagename] != null) {
      return MaterialPageRoute(
          settings: settings, builder: (_) => _Page[pagename]);
    }
    else {
      return MaterialPageRoute(builder: (context) => UnknownScreen());
    }
  }

  static $Get_PagePar(context) {
    if (ModalRoute
        .of(context)
        .settings
        .name != null) {
      final settingsUri = Uri.parse(ModalRoute
          .of(context)
          .settings
          .name);
      return settingsUri.queryParameters;
    }
    return null;
  }

  static Widget $Youtube(String youtube_code, {double sizeRatio = 2}) {
    print("Youtube Iframe use \$\$Web_Iframe(\"https://www.youtube.com/embed/$youtube_code\")");
    //return $$Web_Iframe(Src: "https://www.youtube.com/embed/$youtube_code",
    //  Frame_size_ratio: sizeRatio,);
  }

  static $AppBar(
      {logo, Widget center_widget, Widget tail_widget, Color color, double maxWidth = 1200, double height = 80, drawer, drawer_color = Colors
          .white, padding = const EdgeInsets.all(10)}) {
    return vWeb_AppBar(
        logo: logo,
        center_widget: center_widget,
        tail_widget: tail_widget,
        background_color: color,
        width: maxWidth,
        padding: padding,
        drawer: drawer,
        height: height,
        drawer_color: drawer_color
    );
  }

  /*
  static _$WebScaffold({webAppBar, body, footer, body_under_appbar = true}) {
    return $$WebScaffold(
      appbar: webAppBar, body: body, body_under_appbar: body_under_appbar,);
  }
  */

  static $Row_Center({child,double max_width=1200})
  {  if(child==null) { return Container();}
     return LayoutBuilder(
      builder: (context, constraints) {
        if(constraints.maxWidth > max_width)
          { return Row(children: [
            vSp(0).expend(),
            vBox(child:child).w(max_width),
            vSp(0).expend(),
          ]);}
        else
          { return child; }
      });
  }

  static $Row_Right({child,double max_width=1200})
  { if(child==null) { return Container();}
    return LayoutBuilder(
      builder: (context, constraints) {
        if(constraints.maxWidth > max_width)
        { return Row(children: [
          vSp(0).expend(),
          vBox(child:child).w(max_width),
        ]);}
        else
        { return child; }
      });
  }

  static $Row_Left({child,double max_width=1200})
  {  if(child==null) { return Container();}
     return LayoutBuilder(
      builder: (context, constraints) {
        if(constraints.maxWidth > max_width)
        { return Row(children: [
          vBox(child:child).w(max_width),
          vSp(0).expend(),
        ]);}
        else
        { return child; }
      });
  }


  static $Responsive(child,
      {child_Mobile, child_Tablet, child_Destop, child_LargeDestop}) {
    return vResponsive(child: child,
        child_Mobile: child_Mobile,
        child_Tablet: child_Tablet,
        child_Destop: child_Destop,
        child_LargeDestop: child_LargeDestop);
  }

  static $Table({List<Widget> headers, List<
      List>table_data, onData, Color row_color = Colors
      .transparent, Color header_color = Colors.transparent}) {
    return _webtable(
        header: headers,
        rows: table_data,
        row_ondata: onData,
        row_color: row_color,
        header_color: header_color);
  }

  static Widget $SwapRow(Widget w1, Widget w2, double w1_ratio,{double row_Space=10, row_crossAxisAligment,col_crossAxisAligment}) {

    Widget row = (w1_ratio==1) ?
    Row(
      crossAxisAlignment: row_crossAxisAligment ?? CrossAxisAlignment.center,
      children: [
        Expanded(child: w1),
        SizedBox(width: row_Space,),
        w2,
      ],):

    Row(
      crossAxisAlignment: row_crossAxisAligment ?? CrossAxisAlignment.center,
      children: [
      Expanded(flex: (w1_ratio * 100).round(), child: w1),
      SizedBox(width: row_Space,),
      Expanded(flex: 100 - (w1_ratio * 100).round(), child: w2),
    ],);

    Widget col = Column(
      crossAxisAlignment: col_crossAxisAligment ?? CrossAxisAlignment.start,
      children: [ w1, w2],);

    //print("SwapRow");
    return Container(
      width: double.infinity,
      child: vResponsive(
        child: row,
        child_Mobile: col,
        child_Tablet: col,
      ),
    );
  }

  static Widget $Column(List childs,
      {mobile_col = 1, tablet_col = 2, destop_col = 4, large_col = 6, onData}) {
    var device_col = [mobile_col, tablet_col, destop_col, large_col];

    return LayoutBuilder(
        builder: (context, constraints) {
          var sid = vSystem.screensize_ID(context);
          int col = device_col[sid];
          if (col == 0) {
            return Container();
          }

          var v = 100 / (col * 100);
          List<Widget> citems = [];
          for (var n = 0; n < childs.length; n++) {
            citems.add(
                FractionallySizedBox(
                    widthFactor: v,
                    child: onData == null ? childs[n] : onData(childs[n])
                )
            );
          }
          return Wrap(alignment: WrapAlignment.start,children: citems);
        });
  }

}

class vWeb_AppBar{
  Drawer drawer;
  Widget center_widget;
  String logo;
  Widget tail_widget;
  Color background_color;
  double width;
  Color drawer_color;
  double height;
  var padding;
  vWeb_AppBar({
    this.center_widget,this.drawer,this.drawer_color,this.logo,this.tail_widget,this.background_color,this.width = 1200,this.height=80, this.padding = const EdgeInsets.all(10)});


}


class _webtable extends StatelessWidget {
  List<Widget> header;
  List<List> rows;
  var row_ondata;
  var row_color;
  var header_color;
  _webtable({this.header,this.rows,this.row_ondata,this.row_color = Colors.transparent,this.header_color=Colors.transparent});

  @override
  Widget build(BuildContext context) {
    return LayoutBuilder(
      builder: (context, constraints) => SingleChildScrollView(
        scrollDirection: Axis.horizontal,
        child: ConstrainedBox(
          constraints: BoxConstraints(minWidth: constraints.maxWidth),
          child: DataTable(
              headingRowColor:  MaterialStateProperty.all(header_color),
              columns: header.map((T){
                return DataColumn(
                    label: T
                );
              }).toList(),

              rows:rows.asMap().entries.map((r){
                return DataRow(
                    color: (row_color!=null && r.key % 2 == 1) ? MaterialStateProperty.all(row_color) : MaterialStateProperty.all(Colors.transparent),
                    cells: r.value.asMap().entries.map((e) {
                      if(row_ondata != null)
                      {  return DataCell(row_ondata(e.key.toInt(),e.value.toString())); }
                      else
                      {  return DataCell(Text(e.value.toString())); }
                    }).toList()
                );
              }).toList()
          ),
        ),
      ),
    );
  }

}


class vResponsive extends StatelessWidget {
  static final Mobile = 0;
  static final Tablet = 1;
  static final Destop = 2;
  static final Large_Destop = 3;

  static var Screen_id = 0;

  @required var child;
  var child_Mobile;
  var child_Tablet;
  var child_Destop;
  var child_LargeDestop;


  vResponsive({Key key,this.child,this.child_Mobile,this.child_Tablet,this.child_Destop,this.child_LargeDestop}) : super(key:key);

  @override
  Widget build(BuildContext context) {
    //print("Responsive");
    return LayoutBuilder(
        builder: (context, constraints) {
          var sid = vSystem.screensize_ID(context);
          //print("Screen sid $sid");
          if(sid==0) { return  child_Mobile ?? child; }
          if(sid==1) { return  child_Tablet ?? child; }
          if(sid==2) { return  child_Destop ?? child; }
          if(sid==3) { return  child_LargeDestop ?? child; }
        });

  }
}


class UnknownScreen extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(),
      body: Center(
        child: vText('404!').h3().bold(),
      ),
    );
  }
}


