import 'dart:convert';
import 'dart:io';
import 'package:dio/dio.dart';
import 'package:flutter/material.dart';
import 'package:image_picker/image_picker.dart';
import 'package:flutter/foundation.dart' show kIsWeb;
import './vSystem.dart';
import './vPopup.dart';
import './vLoading.dart';
import 'Ev/_Image_Get.dart';

class vApi
{    static var debug = true;

     var _onData;
     var _onProgress;
     var _onError;
     var _context;
     Map<String,String> _postvalue;
     var _uploadvalue;

     var _showloading = false;
     var _showError = false;
     var connectTimeout ;

     CancelToken token;
     Dio dio = Dio();

    vApi({this.connectTimeout = 15000}) {
      dio.options.connectTimeout = connectTimeout;
      dio.options.receiveTimeout = 15000;
    }


   void $post_loading(BuildContext context,String url,{postValue, uploadValue,onData,onProgress,onError,LoadingWidget}) {
     this._showloading = true;
     this._showError = true;
     this._context = context;
     this._postvalue = postValue ?? this._postvalue;
     this._uploadvalue = uploadValue ?? this._uploadvalue;
     this._onData = onData ?? this._onData;
     this._onProgress = onProgress ?? this._onProgress;
     this._onError = onError ?? this._onError;
     vLoading.show(_context,loadicon: LoadingWidget);
     Future.delayed(const Duration(milliseconds: 300), () {
      _post(url);
     });
   }

  void $post(String url,{postValue,uploadValue,onData,onProgress,onError}) {
    this._showloading = false;
    this._showError = false;
    this._context = null;
    this._postvalue = postValue ?? this._postvalue;
    this._uploadvalue = uploadValue ?? this._uploadvalue;
    this._onData = onData ?? this._onData;
    this._onProgress = onProgress ?? this._onProgress;
    this._onError = onError ?? this._onError;
    _post(url);
}


 void _post(String url)
    async {

      if(debug)
          { print("Post API $url :" + _postvalue.toString()); }

      token = CancelToken();
      Map<String, dynamic> fordata = Map();
      fordata["lang"] = vSystem.Lang_id;

      if (_postvalue != null) {
        _postvalue.forEach((String key, String value) {
          fordata[key] = value;
        });
      }
      if(debug)
         { print("Upload value:" + _uploadvalue.toString());}

      if(_uploadvalue!=null)
        {  var uploadlist = _uploadvalue.entries.toList();
           for(var v in uploadlist)
             {  String key = v.key;
                if(!kIsWeb) {
                  File file = v.value;
                  fordata[key] =
                  await MultipartFile.fromFile(file.path, filename: file.path
                      .split("/")
                      .last);
                }
                else {
                  print("Picke :" + v.value.path.toString());
                  PickedFile file = pickefile[v.value.path];
                  if(file != null) {
                    var w = await file.readAsBytes();
                    pickefile[v.value.path] = null;
                    fordata[key] = await MultipartFile.fromBytes(w, filename: key);
                  }
                }
             }
        }

      var PostData = new FormData.fromMap(fordata);

      if(debug)
         { print("Post API $url :" + fordata.toString());}

      dio.post(url, data: PostData, cancelToken: token,

       onSendProgress: (int sent, int total) {
          if(_onProgress != null)
            {  _onProgress(sent, total); }})

      .catchError((err) {
        token = null;
        if(this._showloading){ vLoading.hide(); }

        if(err.type == DioErrorType.cancel) {
          print("API Cancel");
          return null;
        }

        print("Catch Error " + err.message.toString() + "." + err.type.toString());

        if (err.type == DioErrorType.response) {
          print(url + " Response ");
        }
        if (err.type == DioErrorType.connectTimeout) {
          print(url + "Connect Timeout ");
        }
        if (err.type == DioErrorType.receiveTimeout) {
          print(url + "Receive Timeout ");
        }

        if (_onError != null) {
            _onError();
        }
        return null;
       }).then((response) {
         token = null;
         if(this._showloading){ vLoading.hide(); }

         if (response != null && response.statusCode == 200) {
           if(debug)
             { print("$url API Success Response :" + response.statusCode.toString() + " : " + response.toString());}

           var decode;
           try{
             decode =  jsonDecode(response.toString());
           } on FormatException catch(e){
             print("API Result Json Format Error!");
             return null;
           }

           if (decode["status"] == 0 && decode["err_message"]
               .toString()
               .isNotEmpty && _showError) {
             vPopup.$Error(_context, decode["err_message"].toString());
           }
           else
           { if (_onData != null) {
             _onData(decode);
           }}
         }

      }); // end CatchError


    }


void $Stop() {
      vLoading.hide();
      if( token != null) {
        token.cancel();
        token = null;
      }

    }
}