import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'Ev/_Api_Builder.dart';
import 'Ev/_Api_ListView.dart';
import 'Ev/_Api_WebListView.dart';
import './vSystem.dart';
import 'Ev/_Image_Get.dart';
import 'vBadge.dart';
import 'vController.dart';

class vBox extends StatefulWidget {
  Widget child;
  String sKey;

  _$$vBoxState _stateitem;

  double _width = null;
  double _height = null;

  double _max_width = double.infinity;
  double _min_width = 0;
  double _max_height = double.infinity;
  double _min_height = 0;

  bool _vscroll = false;
  bool _hscroll = false;
  bool _center = false;

  vBadge _badge;

  Color _color = Colors.transparent;
  double _border_width = 0;
  Color _border_color;

  var _padding = EdgeInsets.all(0);
  var _margin = EdgeInsets.all(0);

  double _opacity = 1.0;
  double _r1 = 0;
  double _r2 = 0;
  double _r3 = 0;
  double _r4= 0;

  bool _shadow = false;
  double _shadow_width = 0;
  var _device_hide = [0,0,0,0,0,0];

  var _onpress = null;
  var _onpress_type = 0;
  var _onhover;
  var _onOver_bcolor;
  var _onTap_color;
  var _onOver_color;
  var _api_data;
  var _onLoaded;

  var _remove = false;

  var _animation = 0;
  int _duration = 0;
  double _crop_ratio = 0;

  vBox({this.child,this.sKey=""});

  vBox r(double round)
  { this._r1 = round;
  this._r2 = round;
  this._r3 = round;
  this._r4 = round;
  return this;}

  vBox c(Color bgcolor)
  { this._color = bgcolor; return this;}

  vBox cw()
  { this._color = Colors.white; return this;}

  vBox none()
  { _remove=true; return this; }

  vBox rtl(double round)
  { this._r1 = round; return this; }

  vBox rtr(double round)
  { this._r2 = round; return this; }

  vBox rbl(double round)
  { this._r4 = round; return this; }

  vBox rbr(double round)
  { this._r3 = round; return this; }

  vBox w(double width)
  { this._width = width; return this;}

  vBox wf()
  { this._width = double.infinity; return this;}

  vBox wh(double width,double height)
  { this._width = width;
    this._height = height;
    return this;
  }

  vBox notify(int count,{Color color=Colors.deepOrangeAccent,Color textColor=Colors.white}) {
    this._badge = vBadge(sKey: sKey + "_notify", count: count,bgcolor: color,textcolor: textColor,);
    return this;
  }

  vBox br_w(double border_width)
  {  this._border_width = border_width;
     this._border_color = this._border_color ?? Colors.grey;
     return this;
  }

  vBox br_c(Color border_color)
  {  this._border_color = border_color;
     this._border_width = (this._border_width==null ? 2 : this._border_width);
     return this;
  }

  vBox br({double border_width = 1,border_color=Colors.grey})
  {  this._border_color = border_color;
     this._border_width   =border_width;
     return this;
  }


  vBox w_limit(double min_width,double max_width)
  { this._min_width = min_width;
  this._max_width = max_width;
  return this;}

  vBox h_limit(double min_height,double max_height)
  { this._min_height = min_height;
  this._max_height = max_height;
  return this;}


  vBox h(double height)
  { this._height = height; return this; }

  vBox padding(EdgePadding)
  { this._padding = EdgePadding; return this; }

  vBox p(double padding_value)
  { this._padding = EdgeInsets.all(padding_value); return this; }

  vBox px(double padding_value)
  { this._padding = EdgeInsets.symmetric(horizontal: padding_value);  return this;}


  vBox py(double padding_value)
  { this._padding = EdgeInsets.symmetric(vertical: padding_value);  return this;}

  vBox pxy(double horizontal,double vertical)
  { this._padding = EdgeInsets.symmetric(horizontal: horizontal, vertical: vertical);  return this;}

  vBox m(double margin_value)
  { this._margin = EdgeInsets.all(margin_value); return this; }

  vBox mx(double margin_value)
  { this._margin = EdgeInsets.symmetric(horizontal: margin_value);  return this;}

  vBox my(double margin_value)
  { this._margin = EdgeInsets.symmetric(vertical: margin_value);  return this;}

  vBox mxy(double horizontal,double vertical)
  { this._margin = EdgeInsets.symmetric(horizontal: horizontal, vertical: vertical);  return this;}


  vBox sd1()
  { this._shadow = true;  this._shadow_width = 1; return this;}

  vBox sd2()
  { this._shadow = true;  this._shadow_width = 2; return this;}

  vBox sd3()
  { this._shadow = true;  this._shadow_width = 3; return this;}

  vBox sd4()
  { this._shadow = true;  this._shadow_width = 4; return this;}

  vBox sd5()
  { this._shadow = true;  this._shadow_width = 5; return this;}



  vBox hide({bool mobile=false,bool tablelet=false,bool destop=false,bool large=false})
  {  this._device_hide[0] = mobile ? 1 : 0;
     this._device_hide[1] = tablelet ? 1 : 0;
     this._device_hide[2] = destop ? 1 : 0;
     this._device_hide[3] = large ? 1 : 0;
     return this;
  }

  vBox hide_M()
  {  this._device_hide[0] = 1; return this; }

  vBox hide_T()
  { this._device_hide[1] = 1; return this; }

  vBox hide_D()
  { this._device_hide[2] = 1; return this; }

  vBox hide_L()
  { this._device_hide[3] = 1; return this; }

  vBox onPress(onPress)
  { this._onpress = onPress;
    this._onpress_type = 0;
    return this;
  }

  vBox onLoaded(onload)
  { this._onLoaded = onload;
    return this;
  }

  vBox onGetimage(onPress,{crop_ratio = 0})
  { this._onpress = onPress;
    this._onpress_type = 1;
    this._crop_ratio =crop_ratio;
   return this;
  }

  vBox onGetFile(onPress)
  { this._onpress = onPress;
    this._onpress_type = 2;
  return this;
  }

  vBox onTap_c(color)
  { this._onTap_color = color;
    return this;
  }

  vBox onOver_c(onOver_bgcolor)
  { this._onOver_color = onOver_bgcolor;
    return this;
  }

  vBox onOver_bc(onOver_bordercolor)
  { this._onOver_bcolor = onOver_bordercolor;
    return this;
  }

  vBox onOver(onhover) {
    this._onhover = onhover;
    return this;
  }

  vBox vscroll()
  { this._vscroll = true;
  return this;
  }

  vBox hscroll()
  { this._hscroll = true;
  return this;
  }

  vBox center()
  { this._center = true;
  return this;
  }

  vBox api_Box(String url,onData,{postvalue}) {
    if(postvalue==null)
    { postvalue = {"lang":vSystem.Lang_id}; }
    else
    { postvalue["lang"] = vSystem.Lang_id; }

    this._api_data = this._api_data ?? Map();
    this._api_data["type"] = "api_page";
    this._api_data["url"] = url;
    this._api_data["post"] = postvalue;
    this._api_data["ondata"] = onData;
    return this;
  }

  vBox api_Webpageview(String url,onData_sdata,
      { col_Mobile=2,col_TableLet=6,col_Destop=6,col_Large=8,
        postvalue,pagesize=30,nodata_text = "No Data",
        pageButton_focus_color = Colors.red,
        pageButton_fontcolor = Colors.black,
        pageButton_bgcolor = Colors.white,
        int page_xalign = 1,
        int page_yalign = 1,
        item_align = CrossAxisAlignment.start,
      })
  {  // page_valign = 0:top. 1:button
    if(postvalue==null)
    { postvalue = {"lang":vSystem.Lang_id}; }
    else
    { postvalue["lang"] = vSystem.Lang_id; }

    this._api_data = this._api_data ?? Map();
    this._api_data["type"] = "api_web_listview";
    this._api_data["url"] = url;
    this._api_data["post"] = postvalue;
    this._api_data["ondata"] = onData_sdata;
    this._api_data["pagesize"] = pagesize;
    this._api_data["nodata_text"] = nodata_text;
    this._api_data["col_Mobile"] = col_Mobile;
    this._api_data["col_TableLet"] = col_TableLet;
    this._api_data["col_Destop"] = col_Destop;
    this._api_data["col_Large"] = col_Large;
    this._api_data["pagvButton_focus_color"] = pageButton_focus_color;
    this._api_data["pagvButton_fontcolor"] = pageButton_fontcolor;
    this._api_data["pagvButton_bgcolor"] = pageButton_bgcolor;
    this._api_data["page_xalign"] = page_xalign;
    this._api_data["page_yalign"] = page_yalign;
    this._api_data["item_align"] = item_align;


    return this;
  }

  vBox api_Listview(url,onData_sdata,{ postvalue,pagesize=20,onDelete, nodata_text = "No Data",int column=1,double column_ratio = 1.0})
  {   if(postvalue==null)
  { postvalue = {"lang":vSystem.Lang_id}; }
  else
  { postvalue["lang"] = vSystem.Lang_id; }

  this._api_data = Map();
  this._api_data["type"] = "api_listview";
  this._api_data["url"] = url;
  this._api_data["post"] = postvalue;
  this._api_data["ondata"] = onData_sdata;
  this._api_data["ondelete"] = onDelete;
  this._api_data["pagesize"] = pagesize;
  this._api_data["nodata_text"] = nodata_text;
  this._api_data["column"] = column;
  this._api_data["column_ratio"] = column_ratio;
  return this;
  }


  vBox an_fadein({int duration_millsecond=300})
  {  this._animation =1;
     this._duration = duration_millsecond;
     return this;
  }

  vBox an_scalein({int duration_millsecond=300})
  {  this._animation =2;
     this._duration = duration_millsecond;
     return this;
  }

  vBox an_rightin({int duration_millsecond=300})
  {  this._animation = 3;
     this._duration = duration_millsecond;
    return this;
  }

  vBox an_downin({int duration_millsecond=300})
  {  this._animation = 4;
     this._duration = duration_millsecond;
     return this;
  }

  static vBox $skey(String skey)
  { return $$vController.box_items[skey]; }


  void $hide() {
      _remove = false;
      _stateitem.show(0.0);
  }

  void $show() {
      _remove = false;
      _stateitem.show(1.0);
  }

  void $remove() {
       //print("vBox Remove " + sKey  + _stateitem.toString());
      if(_stateitem.mounted)
      { _stateitem.setState(() {
          _remove = true;
      }); }
  }

  void $set_notify(int count) {
    //print("badge " + _badge.toString());
    if (_badge != null) {

      vBadge.$skey(sKey + "_notify").$count(count);
    }
  }

  void $child(child)
  {  _stateitem.change_chlid(child); }

  void $child_fadeIn(child,{duration_millsec_time = 400})
  {  _stateitem.FadeIn_Child(child,duration_millsec_time);
  }

  void $child_ScaleIn(child,{duration_millsec_time = 400})
  {  _stateitem.ScaleIn_Child(child,duration_millsec_time);
  }

  void $child_LeftIn(child,{duration_millsec_time = 400})
  {  _stateitem.LeftIn_Child(child,duration_millsec_time);
  }

  void $child_DownIn(child,{duration_millsec_time = 400})
  {  _stateitem.DownIn_Child(child,duration_millsec_time);
  }

  void $api_reload({String url,postvalue})
  { if(this._api_data==null)
    {  print("No API　Ｓetting , Cannot Reload");  return; }

    //print("api reload type:" + this._api_data["type"]);
    if(postvalue != null)
       { postvalue["lang"] = vSystem.Lang_id; }

    switch(this._api_data["type"])
    {  case  "api_listview":
       this._api_data["listview"].reload(url:url,post:postvalue);
       break;

      case "api_page":
        var api = url ?? this._api_data["url"];
        var post = postvalue ?? this._api_data["post"];
        _stateitem.post_reload(api,post);
        break;

      case "api_web_listview":
        var api = url ?? this._api_data["url"];
        var post = postvalue ?? this._api_data["post"];
        _stateitem.post_reload(api,post);
        break;
    };
  }

  @override
  _$$vBoxState createState() {
    $$vController.box_items[sKey] = this;
    _stateitem = _$$vBoxState();
    return _stateitem;
  }
}

class _$$vBoxState extends State<vBox> {

  var disable = false;
  var ontap = false;
  var onOver = false;
  GlobalKey<__animation_State> _fadeinkey;


  void initState() {
    // if(widget.sKey!="")
    //  {  $$vController.box_items[widget.sKey] = widget; }

  }

  @override
  void dispose() {
    //print("sBox Despoit " + widget.sKey.toString());
    //$$vController.box_items[widget.sKey] = null;
    super.dispose();
  }

  void change_chlid(child)
  {  setState(() {
          widget.child = child;
     });
  }

  void post_reload(url, post) {
    setState(() {
      widget._api_data["post"] = post;
      widget._api_data["url"] = url;
    });
  }


  void FadeIn_Child(child,duration_millsec_time)
  {
    setState(() {
      _fadeinkey = null;
      widget._animation = 1;
      widget._duration = duration_millsec_time;
      widget.child = child;
    });

  }

  void ScaleIn_Child(child,duration_millsec_time)
  {
    setState(() {
      _fadeinkey = null;
      widget._animation = 2;
      widget._duration = duration_millsec_time;
      widget.child = child;
    });

  }

  void LeftIn_Child(child,duration_millsec_time)
  {
    setState(() {
      widget._animation = 3;
      widget._duration = duration_millsec_time;
      widget.child = child;
    });

  }

  void DownIn_Child(child,duration_millsec_time)
  { setState(() {
    widget._animation = 4;
    widget._duration = duration_millsec_time;
    widget.child = child;
  });
  }


  void show(opacity) {
    setState(() {
      widget._opacity = opacity;
    });
  }


  @override
  Widget build(BuildContext context) {

    WidgetsBinding.instance.addPostFrameCallback((_) {
      if(widget._onLoaded!=null)
      { widget._onLoaded(); }
    });


    var output_child =  widget.child ?? Container();

    var tapcolor = widget._onTap_color ?? widget._color ;
    var overcolor = widget._onOver_color ?? widget._color;
    var br_overcolor = widget._onOver_bcolor ?? (widget._border_color ?? Colors.transparent);

    var decoration = BoxDecoration(
      border: Border.all(
        color: onOver ? br_overcolor : (widget._border_color ?? Colors.transparent),
        width: widget._onOver_bcolor != null && onOver ? 2 : widget._border_width,
      ),

      color:  onOver ? overcolor :  ( ontap ? tapcolor: widget._color),
      borderRadius: BorderRadius.only(
          topLeft: Radius.circular(widget._r1),
          topRight: Radius.circular(widget._r2),
          bottomRight: Radius.circular(widget._r3),
          bottomLeft: Radius.circular(widget._r4)),
      boxShadow: widget._shadow ?
      [ BoxShadow(
        color: Colors.black.withOpacity(0.2),
        blurRadius: widget._shadow_width,
        offset: Offset(widget._shadow_width/2, widget._shadow_width/2), // changes position of shadow
      ),
      ] : null,
    );

    if (widget._remove) {
      return Container();
    }

    if(widget._badge!=null) {
      output_child = Stack(children: [
        output_child,
        Positioned(top: 0,right: 0,child: widget._badge,)
      ],);
    }

    //print("Build child "+ output_child.toString());
    if(widget._api_data != null)
    {  output_child = api_widget();

    }

    if(widget._center)
    {  output_child = Center(child:output_child); }

    if(widget._vscroll)
    {  output_child = SingleChildScrollView(child: output_child); }

    if(widget._hscroll)
    {  output_child = SingleChildScrollView(
        scrollDirection: Axis.horizontal,
        child: output_child); }

    //print("ebox width " + widget._width.toString());

    output_child = Container(padding: widget._margin, child:
    Container(
      padding: widget._padding,
      width:widget._width,
      height: widget._height,
      child: output_child,
      constraints: BoxConstraints(minWidth: widget._min_width, maxWidth: widget._max_width,
      minHeight: widget._min_height, maxHeight:widget._max_height,
      ),
      decoration: decoration,
    ));

    if(widget._onpress != null)
    {  output_child = Material(
      color: Colors.transparent,
      child: InkWell(
          hoverColor: Colors.transparent,
          highlightColor: Colors.transparent,
          splashColor: Colors.transparent,
          onTapDown: (TapDownDetails details) {
            setState(() {
              ontap = true;
            });
          },
          onTap: (){
            setState(() {
              ontap = false;
              onpress();
            });
          },
          onHover: (isHovering) {
            setState(() {
              onOver = isHovering;
              if(widget._onhover!=null && isHovering)
                { widget._onhover(); }

              if(!isHovering)
                {  ontap = false; }
            });
          },

          child: output_child),
    );
     }


    Widget bchild =  Opacity(
        opacity: widget._opacity,
        child: output_child);

    if (widget._device_hide.reduce((a, b) => a + b) > 0) {
      //print("Box " + widget.sKey + ", Build Layout build");
      return LayoutBuilder(
          builder: (context, constraints) {
            var sid = vSystem.screensize_ID(context);
            //print("Box " + widget.sKey + " Screen $sid " +  widget._device_hide[sid].toString());

            if ( widget._device_hide[sid] == 1) {
                return Container();
            }
            else {
              return animation(bchild);
            }
          });
    }
    else
    {  return animation(bchild); }

  }

  Widget animation(child) {
    if (widget._animation > 0) {
      Widget an_widget = _animation(child,widget._animation,widget._duration);
      if(widget._animation>2)
        an_widget =  Container(width: widget._width, height: widget._height,child: an_widget);
      return an_widget;
    }
    else
    { return child; }
  }

  Widget api_widget()
  {   switch(widget._api_data["type"].toString())
  {
    case "api_page":
      return $$Api_Builder(api: widget._api_data["url"],
          post: widget._api_data["post"],
          onData: (s) {
            return widget._api_data["ondata"](s);
          });

      break;

    case "api_listview":
      var a = widget._api_data;
      widget._api_data["listview"] = $$Api_ListView(url:a["url"],post:a["post"],
          pagesize: a["pagesize"],
          table_item: a["ondata"],
          nodata_text: a["nodata_text"],
          column: a["column"],
          gridRatio: a["column_ratio"],
          ondelete:a["ondelete"]
      );
      return  widget._api_data["listview"];
      break;

    case "api_web_listview":
      var a = widget._api_data;

      return  $$Api_WebListView(url:a["url"],post:a["post"],
        onData: a["ondata"],
        pagesize: a["pagesize"],
        nodata_text: a["nodata_text"],
        mobile_col: a["col_Mobile"],
        tablet_col: a["col_TableLet"],
        destop_col:a["col_Destop"],
        large_destop_col:a["col_Large"],
        pagvButton_focus_color:a["pagvButton_focus_color"],
        pagvButton_fontcolor:a["pagvButton_fontcolor"],
        pagvButton_bgcolor:a["pagvButton_bgcolor"],
        page_xalign: a["page_xalign"],
        page_yalign: a["page_yalign"],
        item_align: a["item_align"],
      );


  }
  }

  void onpress() {
    switch (widget._onpress_type) {
      case 0:
        widget._onpress();
        break;

      case 1:
        if (kIsWeb) {
          $$Image_Get.Get_From_Gallery(context, crop_ratio: 0).then((image) {
            widget._onpress(image);
          });
        }
        else {
          $$Image_Get.Get_Select_Image(context, onReceived: widget._onpress,crop_ratio: widget._crop_ratio);
        }
        break;

      case 2:
        if (kIsWeb) {
          $$Image_Get.Get_From_Gallery(context, crop_ratio: 0).then((image) {
            widget._onpress(image);
          });
        }
        else {
          $$Image_Get.Get_Select_File(context, widget._onpress);
        }
        break;
    }
  }


}

class _animation extends StatefulWidget {

  var child;
  int animation;
  int duration;

  _animation(this.child,this.animation,this.duration);

  @override
  __animation_State createState() => __animation_State();
}

class __animation_State extends State<_animation> with TickerProviderStateMixin {
  AnimationController _controller;
  Animation<double> _animation;

  initState() {
    super.initState();
    _controller = AnimationController(
        duration: Duration(milliseconds: widget.duration), vsync: this, value: 0.3);
    _animation = CurvedAnimation(parent: _controller, curve: Curves.ease);
    _controller.forward();
  }

  @override
  dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {

    switch(widget.animation) {
      case 1:
        return TweenAnimationBuilder<double>(
            tween: Tween<double>(begin: 0, end: 1),
            duration: Duration(milliseconds: widget.duration),
            builder: (BuildContext context, double size, Widget child) {
              print("Double :" + size.toString());
              return Opacity(child: widget.child, opacity: size);
            });
        break;

      case 2:
        return ScaleTransition(
            scale: _animation,
            alignment: Alignment.center,
            child: widget.child
        );
        break;

      case 3:
        return TweenAnimationBuilder<double>(
            tween: Tween<double>(begin: 150, end: 0),
            duration: Duration(milliseconds: widget.duration),
            builder: (BuildContext context, double size, Widget child) {
              print("Double :" + size.toString());
              return   Padding(padding: EdgeInsets.only(left: size),
                  child: Opacity(child: widget.child,opacity:  1 - size/150,)
              );
            });

        break;

      case 4:
        return TweenAnimationBuilder<double>(
            tween: Tween<double>(begin: 150, end: 0),
            duration: Duration(milliseconds: widget.duration),
            builder: (BuildContext context, double size, Widget child) {
              print("Double :" + size.toString());
              return   Padding(padding: EdgeInsets.only(top: size),
                  child: Opacity(child: widget.child,opacity:  1 - size/150,)
              );
            });

        break;
    }
    return Container();
  }
}
