import 'dart:ui';
import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import './vSystem.dart';
import 'Ev/_Image_Get.dart';
import 'vController.dart';

class vIcon extends StatefulWidget {

  static double $IconSize = 40;
  static Color $IconColor = Colors.white;
  static Color $Hover_Color = Colors.orange;
  static Color $OnTap_Color = Colors.orange;

  IconData _icon;
  Color _iconcolor = $IconColor;
  double _iconsize = $IconSize;
  Color _hover_color = $Hover_Color;
  Color _onTap_color = $OnTap_Color;

  String sKey;

  _vIconState _stateitem;

  var _margin = EdgeInsets.all(4);

  double _opacity = 1.0;
  var _device_hide = [0,0,0,0,0,0];

  var _onpress = null;
  var _onpress_type = 0;
  var _remove = false;


  vIcon(this._icon,{this.sKey="0"});

  vIcon c(Color button_Color)
  { this._iconcolor = button_Color;  return this;}

  vIcon size(double iconsize)
  { this._iconsize = iconsize;  return this;}


  vIcon onOver_c(Color hover_Color) {
    this._hover_color = hover_Color;
    return this;
  }

  vIcon onTap_c(Color onTap_Color) {
    this._onTap_color = _onTap_color;
    return this;
  }

  vIcon m(double margin_value)
  { this._margin = EdgeInsets.all(margin_value); return this; }

  vIcon mxy(double horizontal,double vertical)
  { this._margin = EdgeInsets.symmetric(horizontal: horizontal, vertical:  vertical);  return this;}

  vIcon mx(double margin_value)
  { this._margin = EdgeInsets.symmetric(horizontal: margin_value);  return this;}

  vIcon my(double margin_value)
  {
     this._margin = EdgeInsets.symmetric(vertical: margin_value);  return this;}

  vIcon onPress(f)
  {  this._onpress = f;
     this._onpress_type = 0;
     return this;}

  vIcon onGetimage(f)
  {   this._onpress = f;
      this._onpress_type = 1;
      return this;
  }

  vIcon onGetFile(f)
  {    this._onpress = f;
       this._onpress_type = 2;
       return this;
  }

  static vIcon $skey(String k)
  {   return $$vController.vIcon_items[k]; }


  void $hide()
  { _remove = false;
    _stateitem.show(0.0); }

  void $show()
  {  _remove = false;
     _stateitem.show(1.0); }

  void $remove()
   {  _stateitem.setState(() {
         _remove = true;
   });}

  void $icon(IconData icon)
  {  _stateitem.change_icon(icon); }

  vIcon hide({bool mobile=false,bool tablelet=false,bool destop=false,bool large=false})
  {  this._device_hide[0] = mobile ? 1 : 0;
     this._device_hide[1] = tablelet ? 1 : 0;
     this._device_hide[2] = destop ? 1 : 0;
     this._device_hide[3] = large ? 1 : 0;
     return this;
  }

  vIcon h_M()
  {  this._device_hide[0] = 1; return this; }

  vIcon h_T()
  { this._device_hide[1] = 1; return this; }

  vIcon h_D()
  { this._device_hide[2] = 1; return this; }

  vIcon h_L()
  { this._device_hide[3] = 1; return this; }


  @override
  _vIconState createState() {
   _stateitem = _vIconState();
    return _stateitem;
  }
}

class _vIconState extends State<vIcon> {
  var disable = false;
  var onOver = false;
  var onTap = false;
  var color;

  void initState() {
    //print("Init " + widget.toString());
    color = widget._iconcolor;
    $$vController.vIcon_items[widget.sKey] = widget;
  }

  @override
  void dispose() {
    // TODO: implement dispose
    //print("Dispose " + widget.sKey);
    //$$vController.vIcon_items[widget.sKey] = null;
    super.dispose();
  }

  void change_icon(icon) {
    setState(() {
      widget._iconcolor = icon;
    });
  }

  void show(opacity) {
    setState(() {
      widget._opacity = opacity;
    });
  }

  @override
  Widget build(BuildContext context) {
    if (widget._remove) {
      return Container();
    }

    Widget bchild = Opacity(
        opacity: widget._opacity,
        child: Padding(padding: widget._margin,
          child: button(),
        ));

    if (widget._device_hide.reduce((a, b) => a + b) > 0) {
      return LayoutBuilder(
          builder: (context, constraints) {
            var sid = vSystem.screensize_ID(context);
            if (widget._device_hide[sid] == 1) {
              return Container();
            }
            else {
              return bchild;
            }
          });
    }
    else {
      return bchild;
    }
  }

 Widget button() {
   var bchild = Icon(widget._icon,size: widget._iconsize,color:color,);

   if(widget._onpress == null)
     { return bchild; }

   return  Material(
     color: Colors.transparent,
     child: InkWell(
         hoverColor: Colors.transparent,
         highlightColor: Colors.transparent,
         splashColor: Colors.transparent,
         onTapDown: (TapDownDetails details) {
           setState(() {
              color = widget._onTap_color;
           });
         },
         onTap: () {
           setState(() {
             color = widget._iconcolor;
             onpress();
           });
         },
         onHover: (isHovering) {
           setState(() {
                color = isHovering ? widget._hover_color : widget._iconcolor;
            });
         },
         child: bchild),
    );
 }


  void onpress() {
    switch (widget._onpress_type) {
      case 0:
        widget._onpress();
        break;

      case 1:
        if (kIsWeb) {
          $$Image_Get.Get_From_Gallery(context, crop_ratio: 0).then((image) {
            widget._onpress(image);
          });
        }
        else {
          $$Image_Get.Get_Select_Image(context, onReceived: widget._onpress);
        }
        break;

      case 2:
        if (kIsWeb) {
           print("Web Cannot support Upload File");
           widget._onpress(null);
        }
        else {
          $$Image_Get.Get_Select_File(context,
              widget._onpress);
        }
        break;
    }
  }
}