import 'package:ev_framework/_FrameWork/vButton.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import './vSystem.dart';
import 'vBox.dart';
import 'vText.dart';

const  Map<String, String> _close = {'1': 'Close', '2': '關閉', '3': '关闭'};
const  Map<String, String> _yes = {'1': 'Yes', '2': '是', '3': '是'};
const  Map<String, String> _no = {'1': 'No', '2': '否', '3': '否'};
const  Map<String, String> _confirm = {'1': 'Confirm', '2': '確定', '3': '确定'};
const  Map<String, String> _cancel = {'1': 'Cancel', '2': '取消', '3': '取消'};


class vPopup
{  static var widget_context;
static Color $Button_Color = Colors.blue;

static void _showdialog(BuildContext context,Widget child,bool dismiss)
{ var f = 1;
if (kIsWeb) {
  f =  MediaQuery.of(context).size.width > 400 ? 2 : 1;
}

showDialog<String>(
    context: context,
    barrierDismissible: dismiss,
    builder: (BuildContext context) {
      Widget dialog = WillPopScope(
          onWillPop: () {  if(dismiss) {  Navigator.pop(context);}} ,
          child:Padding(
            padding: const EdgeInsets.all(10.0),
            child: Center(child: Column(
              children: [
                Expanded(child: SizedBox(width: 1,),flex: 1,),
                child,
                Expanded(child: SizedBox(width: 1,),flex: f),
              ],
            )),
          ));
      return dialog;
    }
);
}


static void $Error(BuildContext context,String message,{String close_text,onClose,dismiss = true})
{    double w = 300;
if (kIsWeb) {
  w =MediaQuery.of(context).size.width - 100 > 400 ? 400 : MediaQuery.of(context).size.width - 100;
}


var close = close_text==null ? _close[vSystem.Lang_id] : vSystem.lang_text(close_text);
if(onClose!=null)
{ dismiss = false; }

var closebutton = vButton(close).c(Colors.red).outline().r(0).wf().onTap_c(Colors.red.shade50).onOver_c(Colors.red.shade50).onPress((){
  Navigator.pop(context);
  if(onClose != null)
  {  onClose(); }
});

var child = vBox(child: Material(
  color: Colors.transparent,
  child: Column (children: [
    SizedBox(height: 10,),
    Icon(Icons.highlight_off,color: Colors.red,size: w/6,),
    vText(message).p(3).ac(),
    SizedBox(height: 10,),
    closebutton
  ],),
)).c(Colors.white.withOpacity(0.9)).r(10).w(w).pxy(10,3).an_scalein();
_showdialog(context,child,dismiss);
}


/*
static void $Success(BuildContext context,String message,{String close_text,onClose})
   {   if(MediaQuery.of(context).size.width > 400) {
         _WebSuccess(context,message,close_text:close_text,onClose:onClose);
       return;
      }
      var close = close_text==null ? _close[vSystem.Lang_id] : vSystem.lang_text(close_text);

      showDialog<String>(
       context: context,
       barrierDismissible: false,
       builder: (BuildContext context) {
         var dialog =  WillPopScope(
             onWillPop: () {},

         child: vBox(child:CupertinoAlertDialog (
           title: Icon(Icons.check_circle_outline,color: Colors.green, size: 50,),
           content: vText(message).p(0).ac(),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(close,style: TextStyle(color:Colors.black54),),
               onPressed: () {
                 Navigator.pop(context);
                 if(onClose != null)
                    {  onClose(); }
               },
             )
           ],
         )).an_downin());
         return dialog;
       }
     );
   }
 */

static void $Success(BuildContext context,String message,{String close_text,onClose,dismiss = true})
{    double w = 300;
if (kIsWeb) {
  w =MediaQuery.of(context).size.width - 100 > 400 ? 400 : MediaQuery.of(context).size.width - 100;
}


var close = close_text==null ? _close[vSystem.Lang_id] : vSystem.lang_text(close_text);
if(onClose!=null)
{ dismiss = false; }

var closebutton = vButton(close).c(Colors.green).r(0).wf().onOver_c(Colors.green.shade800).onTap_c(Colors.green.shade800).onPress((){
  Navigator.pop(context);
  if(onClose != null)
  {  onClose(); }
});


var child = vBox(child:Material(
  child: Column (children: [
    SizedBox(height: 10,),
    Icon(Icons.check_circle_outline,color: Colors.green,size: w/6,),
    vText(message).p(5).ac(),
    SizedBox(height: 10,),
    closebutton,
  ],),
)).c(Colors.white.withOpacity(0.9)).r(10).w(w).pxy(10,3).an_scalein();
_showdialog(context,child,dismiss);
}

/*
  static void $Warning(BuildContext context,String message,{String close_text,onClose})
   {  if(MediaQuery.of(context).size.width > 400) {
        _WebWarning(context,message,close_text:close_text,onClose:onClose);
       return;
     }
     var close = close_text==null ? _close[vSystem.Lang_id] : vSystem.lang_text(close_text);

     showDialog<String>(
       context: context,
       barrierDismissible: false,
       builder: (BuildContext context) {
         var dialog = vBox(child:CupertinoAlertDialog (
           title: new Icon(Icons.error_outline,color: Colors.orangeAccent.shade700,size: 50,),
           content: vText(message).p(0).ac(),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(close,style: TextStyle(color:Colors.black54),),
               onPressed: () {
                 Navigator.pop(context);
                 if(onClose != null)
                   {  onClose(); }
               },
             )
           ],
         )).an_scalein();
         return dialog;
       }
      );
   }

 */

static void $Warning(BuildContext context,String message,{String close_text,onClose,dismiss = true})
{   double w = 300;

if (kIsWeb) {
  w =MediaQuery.of(context).size.width - 100 > 400 ? 400 : MediaQuery.of(context).size.width - 100;
}

var close = close_text==null ? _close[vSystem.Lang_id] : vSystem.lang_text(close_text);
if(onClose!=null)
{ dismiss = false; }

var closebutton = vButton(close).c(Colors.orangeAccent.shade700).outline().onOver_c(Colors.orangeAccent.shade100).onTap_c(Colors.orangeAccent.shade100).r(0).wf().onPress((){
  Navigator.pop(context);
  if(onClose != null)
  {  onClose(); }
});


var child = vBox(child:Material(
  child: Column (children: [
    SizedBox(height: 10,),
    Icon(Icons.error_outline,color: Colors.orangeAccent.shade700,size: w/6,),
    vText(message).p(3).ac(),
    SizedBox(height: 10,),
    closebutton
  ],),
)).c(Colors.white.withOpacity(0.9)).r(10).w(w).an_scalein().pxy(10,3);
_showdialog(context,child,dismiss);


}


static void $Confirm(BuildContext context,String title,String message,{confirm_text,cancel_text,onConfirm,color=Colors.blue})
{  var confirm = confirm_text==null ? _confirm[vSystem.Lang_id] : vSystem.lang_text(confirm_text);
var cancel = cancel_text==null ? _cancel[vSystem.Lang_id] : vSystem.lang_text(cancel_text);

//if(MediaQuery.of(context).size.width > 400) {
_Web2button(context, title, message, confirm,cancel,onConfirm,null,color);
return;
//}

showDialog(
    context: context,
    barrierDismissible: true,
    builder: (BuildContext context) {
      var dialog = vBox(child:CupertinoAlertDialog (
        title: vText(title).p(2).size(18).ac().bold(),
        content: vText(message).p(0).ac(),
        actions: <Widget>[
          CupertinoDialogAction(isDefaultAction: true,
            child: Text(confirm),
            onPressed: () {
              Navigator.pop(context);
              if(onConfirm != null)
              {  onConfirm(); }
            },
          ),
          CupertinoDialogAction(
            child: Text(cancel,style:TextStyle(color:Colors.black54)),
            onPressed: () {
              Navigator.pop(context);
            },
          )
        ],
      )).an_scalein();
      return dialog;
    });
}

static void _Web2button(BuildContext context,String title, String message,String b1,String b2,onb1,onb2,color)
{    Color bcolor = color ?? $Button_Color;

double w = MediaQuery.of(context).size.width - 100 > 400 ? 400 : MediaQuery.of(context).size.width - 100;
Widget b1_button = vButton(b1).c(bcolor.withOpacity(0.85)).r(0).wf().m(1).onOver_c(bcolor).onTap_c(color).onPress(() async {
  await Navigator.pop(context);
  if(onb1 != null)
  {  onb1(); }
});

Widget b2_button = vButton(b2).c(Colors.grey.withOpacity(0.85)).r(0).wf().m(1).onOver_c(Colors.grey).onTap_c(Colors.grey).onPress(() async {
  await Navigator.pop(context);
  if(onb2 != null)
  {  onb2(); }
});

var child = vBox(child:Material(
  child: Column (children: [
    SizedBox(height: 10,),
    (title!="") ? vText(title).p(3).ac().bold().h1(): Container(),
    Icon(Icons.wb_incandescent,color:color,size: w/8,),
    SizedBox(height: 8,),
    vText(message).p(3).ac(),
    SizedBox(height: 10,),
    Padding(
      padding: const EdgeInsets.all(8.0),
      child: Row(children: [
        Expanded(child:b1_button),
        Expanded(child: b2_button),
      ],),
    ),

  ],),
)).c(Colors.white.withOpacity(0.9)).r(10).w(w).an_scalein().pxy(10,3);
_showdialog(context,child,false);
}


static void $YesNo(BuildContext context,String title,String message,{String yes_text,String no_text,onYes,onNo})
{    var yes = yes_text==null ? _yes[vSystem.Lang_id] : vSystem.lang_text(yes_text);
var no = no_text==null ? _no[vSystem.Lang_id] : vSystem.lang_text(no_text);

// if(MediaQuery.of(context).size.width > 400) {
_Web2button( context, title, message, yes,no,onYes,onNo,Colors.blue);
return;
//}

showDialog(
    context: context,
    barrierDismissible: false,
    builder: (BuildContext context) {
      var dialog =
      WillPopScope(
          onWillPop: () { print("Back Press");},
          child: vBox(child:CupertinoAlertDialog (
            title: vText(title).p(2).size(18).ac().bold(),
            content: vText(message).p(0).ac(),
            actions: <Widget>[
              CupertinoDialogAction(isDefaultAction: true,
                child: Text(yes),
                onPressed: () {
                  Navigator.pop(context);
                  if(onYes != null)
                  {  onYes(); }
                },
              ),
              CupertinoDialogAction(
                child: Text(no,style:TextStyle(color:Colors.black54)),
                onPressed: () {
                  Navigator.pop(context);
                  if(onNo != null)
                  {  onNo(); }
                },
              )
            ],
          ),
          ).an_scalein());
      return dialog;
    });
}



static $Widget(BuildContext context,{Widget child,double max_height = 600,double max_width=400,CanBack = true})
{print("Screen id " + vSystem.Screen_id.toString());
double w = 350;
var f = 1;
widget_context = context;


if (kIsWeb) {
  double w = MediaQuery.of(context).size.width - 50 > max_width ? max_width : MediaQuery.of(context).size.width - 50;
  f =  MediaQuery.of(context).size.width>400 ? 2 : 1;
}

showDialog<String>(
    context: context,
    barrierDismissible: CanBack,
    builder: (BuildContext context) {
      Widget dialog =
      WillPopScope(
        onWillPop: () {
          if (CanBack) {
            Navigator.pop(context);
          }
        },

        child: Padding(
          padding: const EdgeInsets.all(10.0),
          child: Column(
            children: [
              Expanded(child: SizedBox(width: 1,),flex: 1,),
              vBox(child: Material(child:child)).p(0).w(w).an_scalein(),
              Expanded(child: SizedBox(width: 1,),flex: f),
            ],
          ),
        ),
      );
      return dialog;
    }
);


  /*
       showDialog(
           context: context,
           barrierDismissible: CanBack,
           builder: (BuildContext context) {
             var dialog = WillPopScope(
                 onWillPop: () {
                   if (CanBack) {
                     Navigator.pop(context);
                   }
                 },
                 child: Container(
                     margin: EdgeInsets.all(20),
                     child: Center(child: vBox(child: child).an_scalein())
                 ));
             return dialog;
           });
      */
}

static $Widget_close()
{  if(widget_context != null)
{  //print("Close Widget " + widget_context.toString());
  Navigator.pop(widget_context);
}
}


}