import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';
import './vSystem.dart';
import 'vController.dart';

class vText extends StatefulWidget {
  static double $Text_Size = 16;
  static Map<String,vText> _alias = Map();

  var text;
  String sKey;

  _vTextState _stateitem;

  double _width = null;
  double _height = null;
  bool _remove = false;

  var _padding = EdgeInsets.all(0);

  double _opacity = 1.0;
  Color _color = Colors.black;
  double _fontsize = 16;
  var _fontweight = FontWeight.normal;
  var _textalign = TextAlign.left;
  double _scale = 1;
  var _overflow = null; //TextOverflow.values;

  double _shadow_size = 0;
  Color _shadow_color = Colors.black.withOpacity(0.3);

  var _upper = false;
  var _maxline = 10000;
  var _onpress = null;
  var _decoration = TextDecoration.none;
  var _family = null;
  var _hover_color = Colors.black;
  var _textstyle;
  var _html = false;
  var _device_hide = [0,0,0,0,0,0];

  vText(this.text,{this.sKey="0"});

  vText c(Color color)
  {  this._color = color;
     this._hover_color = this._color;
     return this;
  }

  vText cw()
  {  this._color = Colors.white;
     this._hover_color =  Colors.white;
     return this;
  }

  vText upper()
  { this._upper = true;
    return this;
  }

  vText size(double fontsize)
  {  this._fontsize = fontsize; return this;}

  vText h1()
  {  this._fontsize = $Text_Size + 2; return this;}

  vText h2()
  {  this._fontsize = $Text_Size + 4; return this;}

  vText h3()
  {  this._fontsize = $Text_Size + 8; return this;}

  vText h4()
  {  this._fontsize = $Text_Size + 12; return this;}

  vText h5()
  {  this._fontsize = $Text_Size + 16; return this;}

  vText h6()
  {  this._fontsize = $Text_Size + 20; return this;}

  vText s1()
  {  this._fontsize = $Text_Size  - 2 ; return this;}

  vText s2()
  {  this._fontsize = $Text_Size - 4 ; return this;}

  vText s3()
  {  this._fontsize = $Text_Size - 6 ; return this;}

  vText thin()
  {  this._fontweight = FontWeight.w100; return this;}

  vText bold()
  {  this._fontweight = FontWeight.bold; ; return this;}

  vText w1()
  {  this._fontweight = FontWeight.w600; ; return this;}

  vText w2()
  {  this._fontweight = FontWeight.w700; ; return this;}

  vText w3()
  {  this._fontweight = FontWeight.w800; ; return this;}

  vText w4()
  {  this._fontweight = FontWeight.w900; ; return this;}

   vText none() {
     _remove = true;
     return this;
   }

  vText shadow({double shadow_size=3, Color shadow_color})
  {  this._shadow_size = shadow_size;
     this._shadow_color = shadow_color ?? Colors.black.withOpacity(0.3);
     return this;}

  vText alias(String name) {
    _alias[name] = this;
    return this;
  }

  vText fromAlias(String name)
  {  _alias[name].text = this.text;
     return _alias[name];
  }

  vText al()
  {  this._textalign = TextAlign.left; ; return this;}

  vText ar()
  {  this._textalign = TextAlign.right; ; return this;}

  vText ac()
  {  this._textalign = TextAlign.center; ; return this;}

  vText justify()
  {  this._textalign = TextAlign.justify; ; return this;}

  vText scale(double TextScale)
  {  this._scale = TextScale ; return this;}

  vText ellipsis()
  {  this._overflow = TextOverflow.ellipsis; return this;}

  vText maxline(int maxLines)
  {  this._maxline = maxLines; return this;}

  vText family(String fontFamily)
  {  this._family = fontFamily; return this;}

  vText style(TextStyle style)
  {  this._textstyle = style;
     return this;
   }

  vText underline()
  {  this._decoration = TextDecoration.underline; return this;}


  vText onPress( onPress) {
     this._onpress = onPress;
     return this;
  }

  vText onOver_c(Color hover_color) {
    this._hover_color = hover_color;
    return this;
  }


  vText w(double width)
   { this._width = width; return this;}

  vText wf()
  { this._width = double.infinity;  return this;}

  vText h(double height)
   { this._height = height; return this; }

  vText wh(double width,double height)
  {  this._width = width;
     this._height = height;
     return this;
  }

  vText padding(padding_value)
  { this._padding =padding_value; return this; }


  vText p(double padding_value)
  { this._padding = EdgeInsets.all(padding_value); return this; }

  vText pxy(double horizontal_value,double verical_value)
  {  this._padding = EdgeInsets.symmetric(horizontal: horizontal_value,vertical:verical_value );
     return this;
  }
  vText px(double padding_value)
  { this._padding = EdgeInsets.symmetric(horizontal: padding_value);  return this;}

  vText py(double padding_value)
  { this._padding = EdgeInsets.symmetric(vertical: padding_value);  return this; }

  vText html()
  {  this._html = true; return this;}

  vText hide({bool mobile=false,bool tablelet=false,bool destop=false,bool large=false})
  {  this._device_hide[0] = mobile ? 1 : 0;
  this._device_hide[1] = tablelet ? 1 : 0;
  this._device_hide[2] = destop ? 1 : 0;
  this._device_hide[3] = large ? 1 : 0;
  return this;
  }


  vText h_M()
  {  this._device_hide[0] = 1; return this; }

  vText h_T()
  { this._device_hide[1] = 1; return this; }

  vText h_D()
  { this._device_hide[2] = 1; return this; }

  vText h_L()
  { this._device_hide[3] = 1; return this; }


  static vText $skey(String skey)
  {   return $$vController.text_items[skey]; }

  void $hide() {
      _remove = false;
      _stateitem.show(0.0);}

  void $show()
  {  _remove = false;
     _stateitem.show(1.0); }

  void $remove()
  {  _stateitem.setState(() {
        _remove = true;
     });
  }

  void $Text(text,{TextStyle style})
  {  _stateitem.setState(() {
        this.text = text;
        this._textstyle = style;
     });
  }


  @override
  _vTextState createState() {
   _stateitem = _vTextState();
    return _stateitem;
  }
}

class _vTextState extends State<vText> {
  var disable = false;
  var onhover = false;

  void initState() {
    //print("Init " + widget.toString());
    $$vController.text_items[widget.sKey] = widget;
 }

  @override
  void dispose() {
    // TODO: implement dispose
    //$$vController.text_items[widget.sKey] = null;
    super.dispose();
  }


  void show(opacity) {
    setState(() {
      widget._opacity = opacity;
    });
  }

  @override
  Widget build(BuildContext context) {
    //print("Button Build");
    if (widget._remove) {
      return Container();
    }

    Widget bchild =  Opacity(
        opacity: widget._opacity,
        child: child()
     );

   if (widget._device_hide.reduce((a, b) => a + b) > 0) {
     return LayoutBuilder(
         builder: (context, constraints) {
           var sid = vSystem.screensize_ID(context);
           if (widget._device_hide[sid] == 1) {
             return Container();
           }
           else {
             return bchild;
           }
         });
   }
   else
     {  return bchild; }
  }


  Widget child() {
    String txt = vSystem.lang_text(widget.text.toString());

    if(widget._upper)
      { txt = txt.toUpperCase(); }

    var style = widget._textstyle ?? TextStyle(
        color: (onhover) ? widget._hover_color : widget._color,
        fontSize: widget._fontsize,
        fontWeight: widget._fontweight,
        fontFamily: widget._family,
        decoration: widget._decoration,
        shadows: widget._shadow_size == 0 ? null : <Shadow>[
          Shadow(
              offset: Offset(widget._shadow_size, widget._shadow_size),
              blurRadius: 3.0,
              color: widget._shadow_color
          )
        ]
    );


    Widget text = Text(txt,
      style: style,
      overflow: widget._overflow,
      maxLines: widget._maxline,
      textAlign: widget._textalign,
      textScaleFactor: widget._scale,
    );

    if (widget._html) {
      text = Html(data: txt,);
    }

   text = Container(padding:widget._padding,width: widget._width, height: widget._height, child: text);
    if (widget._onpress != null && !widget._html) {
      text = Material(
        color: Colors.transparent,
        child: InkWell(
          hoverColor: Colors.transparent,
          highlightColor: Colors.transparent,
          splashColor: Colors.transparent,
          child: text,
          onTap: widget._onpress,
          onHover: (isHovering) {
            if (onhover != isHovering)
              setState(() {
                onhover = isHovering;
              });
          },
        ),
      );
    }
    return text;
  }

}

